'***********************************************************
'**
'** p16f876.def : PIC 16f876 specific definitions
'**
'** Copyright (c) 2004, Kyle A. York
'** All rights reserved
'**
'***********************************************************
'
' conventions:
'    PIC registers begin with a '_'
'    after any configuration register follow the configuration bits
'    at the moment, the names are used internally by the PICbsc
'    compiler, so do not change them!
'
'
' not all of these are going to be used, so prevent the
' 'variable...unused' warning
'
' This defines that which is specific to the p16f876
'
pragma WARN OFF           ' no warnings from here down
CONSTANT BYTE _portct = 3 ' only ports A, B, C
include "p16f87x.inc"     ' let's get all of the common stuff

'
' these are used when entering into the ISR
' _isr_w *must* exist in all banks at the same offset. on PICs
' without a shared region at the top, it should be
' set to the lowest value common to all banks
'
BYTE VOLATILE _isr_w      @$007c [ALL]
BYTE VOLATILE _isr_status @$007e [ALL]
BYTE VOLATILE _isr_pclath @$007f [ALL]
'
' this is needed by the pic code
'
BYTE VOLATILE _loop       @$0020
'
' define the DATA areas
'
pragma DATA      $20,$7F
pragma DATA      $a0,$ef
pragma DATA      $110,$16f
pragma DATA      $190,$1ef

pragma CODE      8192 ' amount of code space available

pragma WARN ON
