'***********************************************************
'**
'** p16f87x.def : PIC 16f87x specific definitions
'**
'** Copyright (c) 2004, Kyle A. York
'** All rights reserved
'**
'***********************************************************
'
' conventions:
'    PIC registers begin with a '_'
'    after any configuration register follow the configuration bits
'    at the moment, the names are used internally by the PICbsc
'    compiler, so do not change them!
'
'
' not all of these are going to be used, so prevent the
' 'variable...unused' warning
'
' This defines all commonality between the p16f873/4/6/7
' nb: the constant _portct *must* be set prior to including
'     this file so we'll know how big to make the _port and _tris
'     arrays
'
'
' bank0
'
BYTE VOLATILE _ind        @ $0000 [ALL]
BYTE VOLATILE _tmr0       @ $0001 [0,2]
BYTE VOLATILE _pcl        @ $0002 [ALL]
BYTE VOLATILE _status     @ $0003 [ALL]
  CONSTANT BYTE _irp    = 7
  CONSTANT BYTE _rp1    = 6
  CONSTANT BYTE _rp0    = 5
  CONSTANT BYTE _not_to = 4
  CONSTANT BYTE _not_pd = 3
  CONSTANT BYTE _z      = 2
  CONSTANT BYTE _dc     = 1
  CONSTANT BYTE _c      = 0
BYTE VOLATILE _fsr        @ $0004 [ALL]
BYTE VOLATILE _port(_portct)  @ $0005
BYTE VOLATILE _porta      @ $0005
BYTE VOLATILE _portb      @ $0006 [0,2]
BYTE VOLATILE _portc      @ $0007
BYTE VOLATILE _pclath     @ $000a [ALL]
BYTE VOLATILE _intcon     @ $000b [ALL]
  CONSTANT BYTE _gie  = 7
  CONSTANT BYTE _peie = 6
  CONSTANT BYTE _t0ie = 5
  CONSTANT BYTE _inte = 4
  CONSTANT BYTE _rbie = 3
  CONSTANT BYTE _t0if = 2
  CONSTANT BYTE _intf = 1
  CONSTANT BYTE _rbif = 0
BYTE VOLATILE _pir1       @ $000c
  CONSTANT BYTE _pspif  = 7
  CONSTANT BYTE _adif   = 6
  CONSTANT BYTE _rcif   = 5
  CONSTANT BYTE _txif   = 4
  CONSTANT BYTE _sspif  = 3
  CONSTANT BYTE _ccp1if = 2
  CONSTANT BYTE _tmr2if = 1
  CONSTANT BYTE _tmr1if = 0
BYTE VOLATILE _pir2       @ $000d
  CONSTANT BYTE _eeif   = 4
  CONSTANT BYTE _bclif  = 3
  CONSTANT BYTE _ccp2if = 0
WORD VOLATILE _tmr1       @ $000e ' all 16 bits of _tmr1[lh]
BYTE VOLATILE _tmr1l      @ $000e
BYTE VOLATILE _tmr1h      @ $000f
BYTE VOLATILE _t1con      @ $0010
  CONSTANT BYTE _t1ckps1    = 5
  CONSTANT BYTE _t1ckps0    = 4
  CONSTANT BYTE _t1oscen    = 3
  CONSTANT BYTE _not_t1sync = 2
  CONSTANT BYTE _t1insync   = 2
  CONSTANT BYTE _t1sync     = 2
  CONSTANT BYTE _tmr1cs     = 1
  CONSTANT BYTE _tmr1on     = 0
BYTE VOLATILE _tmr2       @ $0011
BYTE VOLATILE _t2con      @ $0012
  CONSTANT BYTE _toutps3 = 6
  CONSTANT BYTE _toutps2 = 5
  CONSTANT BYTE _toutps1 = 4
  CONSTANT BYTE _toutps0 = 3
  CONSTANT BYTE _tmr2on  = 2
  CONSTANT BYTE _t2ckps1 = 1
  CONSTANT BYTE _t2ckps0 = 0
BYTE VOLATILE _sspbuf     @ $0013
BYTE VOLATILE _sspcon     @ $0014 
  CONSTANT BYTE _wcol  = 7
  CONSTANT BYTE _sspov = 6
  CONSTANT BYTE _sspen = 5
  CONSTANT BYTE _ckp   = 4
  CONSTANT BYTE _sspm3 = 3
  CONSTANT BYTE _sspm2 = 2
  CONSTANT BYTE _sspm1 = 1
  CONSTANT BYTE _sspm0 = 0
WORD VOLATILE _ccpr1      @ $0015 ' all 16 bits of _ccpr1[lh]
BYTE VOLATILE _ccpr1l     @ $0015
BYTE VOLATILE _ccpr1h     @ $0016
BYTE VOLATILE _ccp1con    @ $0017
  CONSTANT BYTE _ccp1x  = 5
  CONSTANT BYTE _ccp1y  = 4
  CONSTANT BYTE _ccp1m3 = 3
  CONSTANT BYTE _ccp1m2 = 2
  CONSTANT BYTE _ccp1m1 = 1
  CONSTANT BYTE _ccp1m0 = 0
BYTE VOLATILE _rcsta      @ $0018
  CONSTANT BYTE _spen     = 7
  CONSTANT BYTE _rx9      = 6
  CONSTANT BYTE _rc9      = 6
  CONSTANT BYTE _not_rc8  = 6
  CONSTANT BYTE _rc8_9    = 6
  CONSTANT BYTE _sren     = 5
  CONSTANT BYTE _cren     = 4
  CONSTANT BYTE _adden    = 3
  CONSTANT BYTE _ferr     = 2
  CONSTANT BYTE _oerr     = 1
  CONSTANT BYTE _rx9d     = 0
  CONSTANT BYTE _rcd8     = 0
BYTE VOLATILE _txreg      @ $0019
BYTE VOLATILE _rcreg      @ $001a
WORD VOLATILE _ccpr2      @ $001b ' all 16 bits of _ccpr2[lh]
BYTE VOLATILE _ccpr2l     @ $001b
BYTE VOLATILE _ccpr2h     @ $001c
BYTE VOLATILE _ccp2con    @ $001d
  CONSTANT BYTE _ccp2x  = 5
  CONSTANT BYTE _ccp2y  = 4
  CONSTANT BYTE _ccp2m3 = 3
  CONSTANT BYTE _ccp2m2 = 2
  CONSTANT BYTE _ccp2m1 = 1
  CONSTANT BYTE _ccp2m0 = 0
BYTE VOLATILE _adresh     @ $001e
BYTE VOLATILE _adcon0     @ $001f
  CONSTANT BYTE _adcs1     = 7
  CONSTANT BYTE _adcs0     = 6
  CONSTANT BYTE _chs2      = 5
  CONSTANT BYTE _chs1      = 4
  CONSTANT BYTE _chs0      = 3
  CONSTANT BYTE _go        = 2
  CONSTANT BYTE _not_done  = 2
  CONSTANT BYTE _go_done   = 2
  CONSTANT BYTE _adon      = 0
'
' bank1
'
BYTE VOLATILE _option_reg @ $0081
  CONSTANT BYTE _not_rbpu = 7
  CONSTANT BYTE _intedg   = 6
  CONSTANT BYTE _t0cs     = 5
  CONSTANT BYTE _t0se     = 4
  CONSTANT BYTE _psa      = 3
  CONSTANT BYTE _ps2      = 2
  CONSTANT BYTE _ps1      = 1
  CONSTANT BYTE _ps0      = 0
BYTE VOLATILE _tris(_portct) @ $0085
BYTE VOLATILE _trisa      @ $0085
BYTE VOLATILE _trisb      @ $0086 [1,3]
BYTE VOLATILE _trisc      @ $0087
BYTE VOLATILE _pie1       @ $008c
  CONSTANT BYTE _pspie  = 7
  CONSTANT BYTE _adie   = 6
  CONSTANT BYTE _rcie   = 5
  CONSTANT BYTE _txie   = 4
  CONSTANT BYTE _sspie  = 3
  CONSTANT BYTE _ccp1ie = 2
  CONSTANT BYTE _tmr2ie = 1
  CONSTANT BYTE _tmr1ie = 0
BYTE VOLATILE _pie2       @ $008d
  CONSTANT BYTE _eeie   = 4
  CONSTANT BYTE _bclie  = 3
  CONSTANT BYTE _ccp2ie = 0
BYTE VOLATILE _pcon       @ $008e
  CONSTANT BYTE _not_por = 1
  CONSTANT BYTE _not_bor = 0
  CONSTANT BYTE _not_bo  = 0
BYTE VOLATILE _sspcon2    @ $0091
  CONSTANT BYTE _gcen    = 7
  CONSTANT BYTE _ackstat = 6
  CONSTANT BYTE _ackdt   = 5
  CONSTANT BYTE _acken   = 4
  CONSTANT BYTE _rcen    = 3
  CONSTANT BYTE _pen     = 2
  CONSTANT BYTE _rsen    = 1
  CONSTANT BYTE _sen     = 0
BYTE VOLATILE _pr2        @ $0092
BYTE VOLATILE _sspadd     @ $0093
BYTE VOLATILE _sspstat    @ $0094
  CONSTANT BYTE _smp          = 7
  CONSTANT BYTE _cke          = 6
  CONSTANT BYTE _d            = 5
  CONSTANT BYTE _i2c_data     = 5
  CONSTANT BYTE _not_a        = 5
  CONSTANT BYTE _not_address  = 5
  CONSTANT BYTE _d_a          = 5
  CONSTANT BYTE _data_address = 5
  CONSTANT BYTE _p            = 4
  CONSTANT BYTE _i2c_stop     = 4
  CONSTANT BYTE _s            = 3
  CONSTANT BYTE _i2c_start    = 3
  CONSTANT BYTE _r            = 2
  CONSTANT BYTE _i2c_read     = 2
  CONSTANT BYTE _not_w        = 2
  CONSTANT BYTE _not_write    = 2
  CONSTANT BYTE _r_w          = 2
  CONSTANT BYTE _read_write   = 2
  CONSTANT BYTE _ua           = 1
  CONSTANT BYTE _bf           = 0
BYTE VOLATILE _txsta      @ $0098
  CONSTANT BYTE _csrc    = 7
  CONSTANT BYTE _tx9     = 6
  CONSTANT BYTE _not_tx8 = 6
  CONSTANT BYTE _tx8_9   = 6
  CONSTANT BYTE _txen    = 5
  CONSTANT BYTE _sync    = 4
  CONSTANT BYTE _brgh    = 2
  CONSTANT BYTE _trmt    = 1
  CONSTANT BYTE _tx9d    = 0
  CONSTANT BYTE _txd8    = 0
BYTE VOLATILE _spbrg      @ $0099
BYTE VOLATILE _adresl     @ $009e
BYTE VOLATILE _adcon1     @ $009f
  CONSTANT BYTE _adfm  = 7
  CONSTANT BYTE _pcfg3 = 3
  CONSTANT BYTE _pcfg2 = 2
  CONSTANT BYTE _pcfg1 = 1
  CONSTANT BYTE _pcfg0 = 0
'
' bank 2
'
BYTE VOLATILE _eedata     @ $010c
BYTE VOLATILE _eeadr      @ $010d
BYTE VOLATILE _eedath     @ $010e
BYTE VOLATILE _eeadrh     @ $010f
'
' bank 3
'
BYTE VOLATILE _eecon1     @ $018c
  CONSTANT BYTE _eepgd = 7
  CONSTANT BYTE _wrerr = 3
  CONSTANT BYTE _wren  = 2
  CONSTANT BYTE _wr    = 1
  CONSTANT BYTE _rd    = 0
BYTE VOLATILE _eecon2     @ $018d

'
' trisc<2> is multiplexed with the _ccp1 module; it's redefined
' here because other PICs multiplex different port/bit combinations
'
BYTE VOLATILE _ccp1_mplex_reg @ $0087 ' _trisc
CONSTANT BYTE _ccp1_mplex_bit = 2

pragma RESTART   $0  ' the restart (power on) vector
pragma INTERRUPT $4  ' the interrupt vector

